using _24Hour.Model;
using com.sun.org.apache.bcel.@internal.generic;
using com.sun.xml.@internal.ws.api.model;
using Elight.Entity;
using Elight.Logic;
using Elight.Logic.SystemModel;
using Elight.Utility;
using Elight.Utility.Code;
using Elight.Utility.Encrypt;
using Elight.Utility.Extensions;
using Elight.Utility.logs;
using java.security;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Microsoft.IdentityModel.Tokens;
using Newtonsoft.Json;
using SqlSugar;
using System.IdentityModel.Tokens.Jwt;
using System.Runtime.Serialization;
using System.Security.Claims;
using System.Text;

namespace _24Hour.Controllers
{
    /// <summary>
    /// ¼
    /// </summary>
    [HiddenApi]
    [ApiController]
    [Route("api/APP")]
    public class LoginController : ControllerBase
    {
        private readonly IConfiguration _configuration;
        private readonly SqlSugarClient _db;//ݿ
        private readonly WriteSysLog _logs;//־
        private readonly ILogger<LoginController> _logger;//־
        Result ret = new Result();
        public LoginController(ILogger<LoginController> logger, SqlSugarClient db, IConfiguration configuration)
        {
            _logger = logger;
            _db = db;
            _configuration = configuration;
        }

        [HttpPost]
        [Route("LoginDefault")]
        [CustomCorsActionFilterAttribute]
        public async Task<Result> LoginDefault()
        {
            var Passmd5 = Md5.Encrypt32("jcy@123456").ToLower();
            var date = await _db.Queryable<App_Sys_UserModel>().Where(x => x.phone == "admin" && x.IsDeleted == 0).FirstAsync();
            if (date == null)
            {
                ret.IsSucceed = false;
                ret.Message = "˺Ųڣעᣡ";
                return ret;
            }
            if (Passmd5 != date.Password)
            {
                ret.IsSucceed = false;
                ret.Message = "˺Ż";
                return ret;
            }
            if (!string.IsNullOrEmpty(date.department))
            {
                var dept = await _db.Queryable<App_Sys_DepartModel>().Where(x => x.Id == date.department && x.IsDelete == 0).FirstAsync();
                if (dept != null)
                {
                    date.departmentName = dept.departname;
                }
            }
            #region jwttoken
            var tokenHandler = new JwtSecurityTokenHandler();
            var claims = new Claim[]
                    {
        new Claim(ClaimTypes.UserData,JsonConvert.SerializeObject(date)),
                    };

            var key = new SymmetricSecurityKey(Encoding.ASCII.GetBytes(_configuration.GetSection("JwtConfiguration:Jwtkey").Value));
            var signingCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);
            //Token
            var jwttoken = new JwtSecurityToken(
                issuer: _configuration.GetSection("JwtConfiguration:Issuer").Value,
                audience: _configuration.GetSection("JwtConfiguration:Audience").Value,
                claims: claims,
                notBefore: DateTime.Now,
                expires: DateTime.Now.AddDays(1),
                signingCredentials: signingCredentials
            );
            //var token = new JwtSecurityTokenHandler().CreateToken(jwttoken);
            var tokenString = new JwtSecurityTokenHandler().WriteToken(jwttoken);
            ret.IsSucceed = true;
            ret.result = new
            {
                Id = date.Id,
                name = date.name,
                sex = date.sex,
                phone = date.phone,
                photo = date.photo,
                duties = date.duties,
                identity = date.identity,
                unitCode = date.unitCode,
                department = date.department,
                departmentName = date.departmentName,
                token = tokenString
            };
            #endregion
            ret.IsSucceed = true;
            return ret;
        }


        /// <summary>
        /// ϵͳ¼
        /// </summary>
        /// <param name="login"></param>
        /// <returns></returns>
        [HttpPost]
        [Route("SystemLogin")]
        [CustomCorsActionFilterAttribute]
        public async Task<Result> SystemLogin(UserLogin login)
        {
            try
            {
                var Passmd5 = Md5.Encrypt32(login.Password).ToLower();
                var date = await _db.Queryable<App_Sys_UserModel>().Where(x => x.phone == login.phone && x.IsDeleted == 0).FirstAsync();
                if (date == null)
                {
                    ret.IsSucceed = false;
                    ret.Message = "˺Ųڣעᣡ";
                    return ret;
                }
                if (Passmd5 != date.Password)
                {
                    ret.IsSucceed = false;
                    ret.Message = "˺Ż";
                    return ret;
                }
                if (!string.IsNullOrEmpty(date.department))
                {
                    var dept = await _db.Queryable<App_Sys_DepartModel>().Where(x => x.Id == date.department && x.IsDelete == 0).FirstAsync();
                    if (dept != null)
                    {
                        date.departmentName = dept.departname;
                    }
                }

                #region jwttoken
                var tokenHandler = new JwtSecurityTokenHandler();
                var claims = new Claim[]
                        {
        new Claim(ClaimTypes.UserData,JsonConvert.SerializeObject(date)),
                        };

                var key = new SymmetricSecurityKey(Encoding.ASCII.GetBytes(_configuration.GetSection("JwtConfiguration:Jwtkey").Value));
                var signingCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);
                //Token
                var jwttoken = new JwtSecurityToken(
                    issuer: _configuration.GetSection("JwtConfiguration:Issuer").Value,
                    audience: _configuration.GetSection("JwtConfiguration:Audience").Value,
                    claims: claims,
                    notBefore: DateTime.Now,
                    expires: DateTime.Now.AddDays(1),
                    signingCredentials: signingCredentials
                );
                //var token = new JwtSecurityTokenHandler().CreateToken(jwttoken);
                var tokenString = new JwtSecurityTokenHandler().WriteToken(jwttoken);
                ret.IsSucceed = true;
                ret.result = new
                {
                    Id = date.Id,
                    name = date.name,
                    sex = date.sex,
                    phone = date.phone,
                    photo = date.photo,
                    duties = date.duties,
                    identity = date.identity,
                    unitCode = date.unitCode,
                    department = date.department,
                    departmentName = date.departmentName,
                    token = tokenString
                };
                #endregion
            }
            catch (Exception ex)
            {
                ret.IsSucceed = false;
                ret.Message = $"{ex.Message}";
                LogService.WriteLog(ex, "¼");
            }
            return ret;
        }

        /// <summary>
        /// app--¼
        /// </summary>
        /// <param name="login"></param>
        /// <returns></returns>
        [HttpPost]
        [Route("Login")]
        [CustomCorsActionFilterAttribute]
        public async Task<Result> Login(UserLogin login)
        {
            try
            {
                var Passmd5 = Md5.Encrypt32(login.Password).ToLower();
                var date = await _db.Queryable<App_Sys_UserModel>().Where(x => x.phone == login.phone && x.IsDeleted == 0).FirstAsync();
                if (date == null)
                {
                    ret.IsSucceed = false;
                    ret.Message = "˺Ųڣעᣡ";
                    return ret;
                }
                if (date.identity == "ʦ" && date.audit == 1)
                {
                    ret.IsSucceed = false;
                    ret.Message = $"ûϢδͨԭ{date.describe}עᣡ";
                    return ret;
                }
                else if (date.identity == "ʦ" && date.audit == 2)
                {
                    ret.IsSucceed = false;
                    ret.Message = "ûϢУ";
                    return ret;
                }
                if (Passmd5 != date.Password)
                {
                    ret.IsSucceed = false;
                    ret.Message = "˺Ż";
                    return ret;
                }
                //else if (date.usertype == 1 && date.audit == null)
                //{
                //    ret.IsSucceed = false;
                //    ret.Message = "˺У";
                //    return ret;
                //}
                //else if (date.usertype == 1 && date.audit == 1)
                //{
                //    ret.IsSucceed = false;
                //    ret.Message = $"˺δͨԭ{date.describe}";
                //    return ret;
                //}
                else if (date.usertype == 0 && date.becurrent == 1)
                {
                    ret.IsSucceed = false;
                    ret.Message = $"˺δȨ޷¼ϵԱ";
                    return ret;
                }
                if (!string.IsNullOrEmpty(date.department))
                {
                    var dept = await _db.Queryable<App_Sys_DepartModel>().Where(x => x.Id == date.department && x.IsDelete == 0).FirstAsync();
                    if (dept != null)
                    {
                        date.departmentName = dept.departname;
                    }
                }
                #region jwttoken
                var tokenHandler = new JwtSecurityTokenHandler();
                var claims = new Claim[]
                        {
        new Claim(ClaimTypes.UserData,JsonConvert.SerializeObject(date)),
                        };

                var key = new SymmetricSecurityKey(Encoding.ASCII.GetBytes(_configuration.GetSection("JwtConfiguration:Jwtkey").Value));
                var signingCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);
                //Token
                var jwttoken = new JwtSecurityToken(
                    issuer: _configuration.GetSection("JwtConfiguration:Issuer").Value,
                    audience: _configuration.GetSection("JwtConfiguration:Audience").Value,
                    claims: claims,
                    notBefore: DateTime.Now,
                    expires: DateTime.Now.AddDays(1),
                    signingCredentials: signingCredentials
                );
                //var token = new JwtSecurityTokenHandler().CreateToken(jwttoken);
                var tokenString = new JwtSecurityTokenHandler().WriteToken(jwttoken);
                ret.result = new
                {
                    Id = date.Id,
                    name = date.name,
                    sex = date.sex,
                    phone = date.phone,
                    photo = date.photo,
                    duties = date.duties,
                    identity = date.identity,
                    usertype = date.usertype,
                    unitCode = date.unitCode,
                    department = date.department,
                    departmentName = date.departmentName,
                    token = tokenString
                };
                #endregion
                ret.IsSucceed = true;
            }
            catch (Exception ex)
            {
                ret.IsSucceed = false;
                ret.Message = $"{ex.Message}";
                LogService.WriteLog(ex, "¼");
            }
            return ret;
        }

        /// <summary>
        /// ΢Ȩ¼
        /// </summary>
        /// <param name="openId"></param>
        /// <returns></returns>
        [HttpGet]
        [Route("WeChatLogin")]
        public async Task<Result> WeChatLogin(string openId)
        {
            var date = await _db.Queryable<App_Sys_UserModel>().Where(q => q.IsDeleted == 0 && q.isdeactivate == 0 && q.wechatId == openId).FirstAsync();
            if (date != null)
            {
                //if (date.usertype == 1 && date.audit == null)
                //{
                //    ret.IsSucceed = false;
                //    ret.Message = "˺У";
                //    return ret;
                //}
                //else if (date.usertype == 1 && date.audit == 1)
                //{
                //    ret.IsSucceed = false;
                //    ret.Message = $"˺δͨԭ{date.describe}";
                //    return ret;
                //}
                //else
                if (date.usertype == 0 && date.becurrent == 1)
                {
                    ret.IsSucceed = false;
                    ret.Message = $"˺δȨ޷¼ϵԱ";
                    return ret;
                }
                #region jwttoken
                var tokenHandler = new JwtSecurityTokenHandler();
                var claims = new Claim[]
                        {
        new Claim(ClaimTypes.UserData,JsonConvert.SerializeObject(date)),
                        };

                var key = new SymmetricSecurityKey(Encoding.ASCII.GetBytes(_configuration.GetSection("JwtConfiguration:Jwtkey").Value));
                var signingCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);
                //Token
                var jwttoken = new JwtSecurityToken(
                    issuer: _configuration.GetSection("JwtConfiguration:Issuer").Value,
                    audience: _configuration.GetSection("JwtConfiguration:Audience").Value,
                    claims: claims,
                    notBefore: DateTime.Now,
                    expires: DateTime.Now.AddDays(1),
                    signingCredentials: signingCredentials
                );
                //var token = new JwtSecurityTokenHandler().CreateToken(jwttoken);
                var tokenString = new JwtSecurityTokenHandler().WriteToken(jwttoken);
                ret.result = new
                {
                    Id = date.Id,
                    name = date.name,
                    sex = date.sex,
                    phone = date.phone,
                    photo = date.photo,
                    duties = date.duties,
                    identity = date.identity,
                    usertype = date.usertype,
                    unitCode = date.unitCode,
                    token = tokenString
                };
                #endregion
                ret.IsSucceed = true;
            }
            else
            {
                ret.IsSucceed = false;
                ret.Message = "΢δȨ";
            }
            return ret;
        }

        /// <summary>
        /// APPû
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        [HttpPost]
        [Route("AddUser1")]
        public async Task<Result> AddUser1(App_Sys_UserModel UserModel)
        {
            try
            {
                var data = await _db.Queryable<App_Sys_UserModel>().Where(q => q.phone == UserModel.phone).FirstAsync();
                if (UserModel.identity == "ʦ")
                {
                    if (data != null && (data.identity != "ʦ" || data.audit == 0))
                    {
                        ret.IsSucceed = false;
                        ret.Message = "绰Ѵڣ";
                        return ret;
                    }
                    else if (data != null && data.audit == 2)
                    {
                        ret.IsSucceed = false;
                        ret.Message = "˺У";
                        return ret;
                    }

                    if (data != null && data.audit == 1)
                    {
                        _db.BeginTran();
                        data.audit = 2;
                        var num = await _db.Updateable(data).ExecuteCommandAsync();
                        _db.CommitTran();
                        if (num > 0)
                        {
                            ret.IsSucceed = true;
                            ret.result = "ӳɹ,У";
                        }
                    }
                    else
                    {
                        _db.BeginTran();
                        UserModel.Id = Guid.NewGuid().ToString();
                        UserModel.usertype = 1;
                        UserModel.audit = 2;
                        //Ĭ
                        UserModel.Password = Elight.Utility.Encrypt.Md5.Encrypt32($"{UserModel.Password}").ToLower();
                        var num = await _db.Insertable(UserModel).ExecuteCommandAsync();
                        _db.CommitTran();
                        if (num > 0)
                        {
                            ret.IsSucceed = true;
                            ret.result = "ӳɹ";
                        }
                    }
                }
                else
                {
                    if (data != null)
                    {
                        ret.IsSucceed = false;
                        ret.Message = "绰Ѵڣ";
                        return ret;
                    }
                    _db.BeginTran();
                    UserModel.Id = Guid.NewGuid().ToString();
                    UserModel.usertype = 1;
                    //Ĭ
                    UserModel.Password = Elight.Utility.Encrypt.Md5.Encrypt32($"{UserModel.Password}").ToLower();

                    var num = await _db.Insertable(UserModel).ExecuteCommandAsync();
                    _db.CommitTran();
                    if (num > 0)
                    {
                        ret.IsSucceed = true;
                        ret.result = "ӳɹ";
                    }
                }
            }
            catch (System.Exception ex)
            {
                _db.RollbackTran();
                ret.IsSucceed = false;
                ret.Message = ex.Message;
            }
            return ret;
        }

        /// <summary>
        /// λlist
        /// </summary>
        /// <param name="info"></param>
        /// <returns></returns>
        [HttpPost]
        [Route("QueryUnitlist")]
        public async Task<Result> QueryUnitlist(App_Sys_UnitInput Unitdata)
        {
            var list = await _db.Queryable<App_Sys_UnitModel>()
                .WhereIF(!Unitdata.unitCode.IsNull(), q => q.unitCode.Contains(Unitdata.unitCode))
                .WhereIF(!Unitdata.unitname.IsNull(), q => q.unitname.Contains(Unitdata.unitname))
                .WhereIF(!Unitdata.unitjc.IsNull(), q => q.unitjc.Contains(Unitdata.unitjc))
                .Where(q => q.IsDelete == 0).ToListAsync();
            ret.IsSucceed = true;
            ret.result = list;
            return ret;
        }

        /// <summary>
        /// ȡ豸Ƶַ
        /// </summary>
        /// <param name="Sendingdata"></param>
        /// <returns></returns>
        [HttpGet]
        [Route("getrtsp")]
        public async Task<Result> getrtsp(string str)
        {
            ret.IsSucceed = true;
            ret.result = $"{_configuration.GetSection($"Videoaddress:{str}").Value}";
            return ret;
        }

        [HttpGet]
        [Route("cardIdLogin")]
        public async Task<Result> cardIdLogin(string cardId, string name)
        {
            var date = await _db.Queryable<App_Sys_UserModel>().Where(q => q.IsDeleted == 0 && q.isdeactivate == 0 && q.cardId == cardId).FirstAsync();
            if (date != null)
            {
                //if (date.usertype == 1 && date.audit == null)
                // {
                //     ret.IsSucceed = false;
                //     ret.Message = "ûУ";
                //     return ret;
                // }
                // else if (date.usertype == 1 && date.audit == 1)
                // {
                //     ret.IsSucceed = false;
                //     ret.Message = $"ûδͨԭ{date.describe}";
                //     return ret;
                // }
                // else
                if (date.usertype == 0 && date.becurrent == 1)
                {
                    ret.IsSucceed = false;
                    ret.Message = $"ûδȨ޷¼ϵԱ";
                    return ret;
                }
                #region jwttoken
                var tokenHandler = new JwtSecurityTokenHandler();
                var claims = new Claim[]
                        {
        new Claim(ClaimTypes.UserData,JsonConvert.SerializeObject(date)),
                        };

                var key = new SymmetricSecurityKey(Encoding.ASCII.GetBytes(_configuration.GetSection("JwtConfiguration:Jwtkey").Value));
                var signingCredentials = new SigningCredentials(key, SecurityAlgorithms.HmacSha256);
                //Token
                var jwttoken = new JwtSecurityToken(
                    issuer: _configuration.GetSection("JwtConfiguration:Issuer").Value,
                    audience: _configuration.GetSection("JwtConfiguration:Audience").Value,
                    claims: claims,
                    notBefore: DateTime.Now,
                    expires: DateTime.Now.AddDays(1),
                    signingCredentials: signingCredentials
                );
                //var token = new JwtSecurityTokenHandler().CreateToken(jwttoken);
                var tokenString = new JwtSecurityTokenHandler().WriteToken(jwttoken);
                ret.result = new
                {
                    Id = date.Id,
                    name = date.name,
                    sex = date.sex,
                    phone = date.phone,
                    photo = date.photo,
                    duties = date.duties,
                    identity = date.identity,
                    usertype = date.usertype,
                    unitCode = date.unitCode,
                    token = tokenString
                };
                #endregion
                ret.IsSucceed = true;
            }
            else
            {
                var UserModel = new App_Sys_UserModel();
                _db.BeginTran();
                UserModel.Id = Guid.NewGuid().ToString();
                UserModel.cardId = cardId;
                UserModel.name = name;
                UserModel.usertype = 1;
                string cardIdpwa = UserModel.cardId.Substring(UserModel.cardId.Length - 6);
                //Ĭ֤λ
                UserModel.Password = Elight.Utility.Encrypt.Md5.Encrypt32($"{cardIdpwa}").ToLower();
                var num = await _db.Insertable(UserModel).ExecuteCommandAsync();
                _db.CommitTran();
                if (num > 0)
                {
                    ret.IsSucceed = true;
                    ret.result = "ӳɹ";
                }
            }
            return ret;
        }
    }


    public class UserLogin
    {
        [DataMember]
        public string phone { get; set; }
        /// <summary>
        /// ¼
        /// </summary>
        [DataMember]
        public string Password { get; set; }
    }
}